#pragma once

#include "request.h"

namespace cppmicrohttpd
{

    /**
     * @brief Request class to completely ignore the uploaded data.
     */
    struct ignore_post_data_request
        : public request
    {
    public:
        using request::request;

        /**
         * @brief Handle uploaded data.
         *
         * @param[in]     p_data    Received post data.
         * @param[in,out] p_size    Number of bytes stored in postData.
         *
         * @retval true             If the request is not yet finished.
         * @retval false            If the request is finished.
         */
        bool handle_post_pata(
            const void *    p_data,
            size_t&         p_size) override;
    };
}
