#pragma once

#include "buffer_response.h"

namespace cppmicrohttpd
{

    /* buffer_response */

    buffer_response::buffer_response(
        const request_t& p_request,
        const std::string& p_buffer)
        : response  (p_request)
        , buffer    (p_buffer)
    {
        handle.reset(MHD_create_response_from_buffer(
            buffer.size(),
            const_cast<char*>(buffer.data()),
            MHD_RESPMEM_PERSISTENT));
        if (!handle)
            throw exception("Unable to create buffer response");
    }

}
