#pragma once

#include "response.h"

namespace cppmicrohttpd
{

    /* callback_response */

    callback_response::callback_response(
        const request_t&    p_request,
        size_t              p_chunk_size,
        ssize_t             p_response_size)
        : response(p_request)
    {
        handle.reset(MHD_create_response_from_callback(
            p_response_size >= 0
                ? static_cast<size_t>(p_response_size)
                : MHD_SIZE_UNKNOWN,
            p_chunk_size,
            &callback_response::mhd_content_reader_callback,
            this,
            nullptr));
        if (!handle)
            throw exception("Unable to create callback response");
    }

}
