#include <sstream>
#include <cppmicrohttpd/response/response.inl>
#include <cppmicrohttpd/response/buffer_response.inl>

using namespace ::cppmicrohttpd;

response_ptr_u response::build_simple_html_response(
    const cppmicrohttpd::request& p_request,
    unsigned int p_status,
    const std::string& p_title,
    const std::string& p_head,
    const std::string& p_msg)
{
    std::ostringstream os;
    os  << "<html><head><title>"
        << p_title
        << "</title></head>"
        << "<body><h1>"
        << p_head
        << "</h1>"
        << p_msg
        << "</body></html>";
    response_ptr_u ret = std::make_unique<buffer_response>(p_request, os.str());
    ret->status = p_status;
    ret->add_header(MHD_HTTP_HEADER_CONTENT_TYPE, "text/html;charset=utf-8");
    return ret;
}
