#include "libmicrohttpd_mock.h"

libmicrohttpd_mock * libmicrohttpd_mock::instance = nullptr;

extern "C"
{

    int MHD_get_fdset2(
        struct MHD_Daemon *daemon,
        fd_set * read_fdset,
        fd_set * write_fdset,
        fd_set * except_fdset,
        int * max_fd,
        unsigned int fdsetsize)
    {
        return libmicrohttpd_mock::instance
            ? libmicrohttpd_mock::instance->MHD_get_fdset2(daemon, read_fdset, write_fdset, except_fdset, max_fd, fdsetsize)
            : MHD_NO;
    }

    int MHD_get_timeout(
        struct MHD_Daemon * daemon,
        MHD_UNSIGNED_LONG_LONG * timeout)
    {
        return libmicrohttpd_mock::instance
            ? libmicrohttpd_mock::instance->MHD_get_timeout(daemon, timeout)
            : MHD_NO;
    }

    int MHD_run_from_select (
        struct MHD_Daemon * daemon,
        const fd_set * read_fdset,
        const fd_set * write_fdset,
        const fd_set * except_fdset)
    {
        return libmicrohttpd_mock::instance
            ? libmicrohttpd_mock::instance->MHD_run_from_select(daemon, read_fdset, write_fdset, except_fdset)
            : MHD_NO;
    }

    struct MHD_Daemon * MHD_start_daemon (
        unsigned int flags,
        uint16_t port,
        MHD_AcceptPolicyCallback apc, void * apc_cls,
        MHD_AccessHandlerCallback dh, void * dh_cls,
        ...)
    {
        return libmicrohttpd_mock::instance
            ? libmicrohttpd_mock::instance->MHD_start_daemon(flags, port, apc, apc_cls, dh, dh_cls)
            : nullptr;
    }

    void MHD_stop_daemon(
        struct MHD_Daemon * daemon)
    {
        if (libmicrohttpd_mock::instance)
            libmicrohttpd_mock::instance->MHD_stop_daemon(daemon);
    }

    int MHD_queue_response(
        struct MHD_Connection * connection,
        unsigned int status_code,
        struct MHD_Response * response)
    {
        return libmicrohttpd_mock::instance
            ? libmicrohttpd_mock::instance->MHD_queue_response(connection, status_code, response)
            : MHD_NO;
    }

    int MHD_add_response_header(
        struct MHD_Response * response,
        const char * header,
        const char * content)
    {
        return libmicrohttpd_mock::instance
            ? libmicrohttpd_mock::instance->MHD_add_response_header(response, header, content)
            : MHD_NO;
    }

    struct MHD_Response * MHD_create_response_from_buffer(
        size_t size,
        void * buffer,
        enum MHD_ResponseMemoryMode mode)
    {
        return libmicrohttpd_mock::instance
            ? libmicrohttpd_mock::instance->MHD_create_response_from_buffer(size, (const char *)buffer, mode)
            : nullptr;
    }

    struct MHD_Response * MHD_create_response_from_callback(
        uint64_t size,
        size_t block_size,
        MHD_ContentReaderCallback crc,
        void * crc_cls,
        MHD_ContentReaderFreeCallback crfc)
    {
        return libmicrohttpd_mock::instance
            ? libmicrohttpd_mock::instance->MHD_create_response_from_callback(size, block_size, crc, crc_cls, crfc)
            : nullptr;
    }

    int MHD_get_connection_values(
        struct MHD_Connection * connection,
        enum MHD_ValueKind kind,
        MHD_KeyValueIterator iterator,
        void * iterator_cls)
    {
        return libmicrohttpd_mock::instance
            ? libmicrohttpd_mock::instance->MHD_get_connection_values(connection, kind, iterator, iterator_cls)
            : MHD_NO;
    }

    void MHD_destroy_response(
        struct MHD_Response * response)
    {
        if (libmicrohttpd_mock::instance)
            libmicrohttpd_mock::instance->MHD_destroy_response(response);
    }

    struct MHD_PostProcessor * MHD_create_post_processor(
        struct MHD_Connection * connection,
        size_t buffer_size,
        MHD_PostDataIterator iter,
        void * iter_cls)
    {
        return libmicrohttpd_mock::instance
            ? libmicrohttpd_mock::instance->MHD_create_post_processor(connection, buffer_size, iter, iter_cls)
            : nullptr;
    }

    int MHD_destroy_post_processor(
        struct MHD_PostProcessor *pp)
    {
        return libmicrohttpd_mock::instance
            ? libmicrohttpd_mock::instance->MHD_destroy_post_processor(pp)
            : MHD_NO;
    }

    int MHD_post_process(
        struct MHD_PostProcessor * pp,
        const char * post_data,
        size_t post_data_len)
    {
        return libmicrohttpd_mock::instance
            ? libmicrohttpd_mock::instance->MHD_post_process(pp, post_data, post_data_len)
            : MHD_NO;
    }

    const char * MHD_lookup_connection_value(
        struct MHD_Connection * connection,
        enum MHD_ValueKind kind,
        const char * key)
    {
        return libmicrohttpd_mock::instance
            ? libmicrohttpd_mock::instance->MHD_lookup_connection_value(connection, kind, key)
            : nullptr;
    }

}
